/*****************************************************************/
/*      ichtooch.cpp - creates och files from  *******.ich       */
/*****************************************************************/

/******************* Declarations and Defines for BYTESWAP **********************/

//#define BYTESWAP							// if defined will enable byte ordering
									// if not defined, byte ordering is disabled

#define _LINUX_

#ifdef BYTESWAP

	unsigned long ByteSwap32 (unsigned long nLongNumber);
	unsigned short ByteSwap16 (unsigned short nValue);

	unsigned long sw_datalong;
	unsigned int sw_dataint;
	unsigned short sw_datashort;

	unsigned long ByteSwap32 (unsigned long nLongNumber)
	{
		unsigned long result32;

		result32 = ((nLongNumber&0x000000FF)<<24) + ((nLongNumber&0x0000FF00)<<8) + ((nLongNumber&0x00FF0000)>>8) 
					+ ((nLongNumber&0xFF000000)>>24);

		return(result32);
	}

	unsigned short ByteSwap16 (unsigned short nValue)
	{
		unsigned short result16;

		result16 = ((nValue>> 8)) | (nValue << 8);
		return (result16);
	}

#endif


/************************************************************************************/

#include<stdlib.h>
#include<stdio.h>
#include<string.h>
//#include<direct.h>	//nakamura commentout
#include<math.h>
#include<sys/stat.h>


#ifdef _LINUX_
#define _MAX_PATH  512
#define _MAX_FNAME 512
#define _MAX_EXT   512
#define _MAX_DRIVE 32
#define _MAX_DIR   512
#endif


#define MAXSAMPLE	192					// maximum number of samples
#define MAXCHANNEL	16					// maximum number of channels
#define MAXNSEQ		65536					// sequence (0 to 65535)
#define MAXPKT		(65536*4)				// dependent
#define FDNUM		64					// maximum number of file desciptors
#define OCHCHAN		4					// och channels

void InitializeArrays();
void rd_ich_payload(unsigned short nsamp, unsigned short nchan);			// read ich payload
void transpose_pkt(unsigned short nsamp, unsigned short nchan);				// create ich payload array tr_data[nchan][nsamp]
void div_pkt(unsigned short ctr, unsigned short nsamp);						// create a 4-channel array from tr_data
void wr_audio(unsigned short nsamp, unsigned short ctr);

//void wr_dummy(unsigned short ctr, unsigned short nsamp);					// for 0x0000 dummy data


void WriteLogFile(unsigned int totalpkt);									// write log file function


void Writeheader(unsigned short ctr);
void createOchName(unsigned short ctr);
void HelpScreen();

unsigned short i, j, k, p, x, y, tmp, fill;
unsigned short plnum, fctrtype;
unsigned short diff, i_diff, diffx, i_diffx;

unsigned int npacket, tpacket, ctrx, ctr, miss, tmiss;					

unsigned short source[(MAXSAMPLE*MAXCHANNEL)];

//unsigned short tr_data[MAXSAMPLE][MAXCHANNEL];					// previous
unsigned short tr_data[MAXCHANNEL][MAXSAMPLE];						// corrected data arrangement

unsigned short div_data[(MAXSAMPLE*OCHCHAN)];

//unsigned short dummy[(MAXSAMPLE*OCHCHAN)];						// for 0x0000 dummy data

char ichfile[_MAX_PATH];

char ochname[FDNUM][_MAX_PATH];
char oname[_MAX_FNAME] = "ochout";
char filecnt[3];
char suffix [_MAX_EXT] = ".och";

   char drive[_MAX_DRIVE];
   char dir[_MAX_DIR];
   char fname[_MAX_FNAME];
   char ext[_MAX_EXT];

   char ochmask[_MAX_FNAME];
   char maskname[_MAX_FNAME];
   char des_dir[_MAX_PATH];

int indicator;
int createlog;

unsigned long ichversion;
unsigned long version;
unsigned int rate;
unsigned int channel;
unsigned short och_pktsize_resv;					// och payload length (reserved)
unsigned short npacketresv, tpacketresv;			// och number of payloads (reserved)
unsigned int resv;									// reserved
unsigned int nseq[MAXPKT]; 
unsigned short seqno[MAXNSEQ];

unsigned short nsamp, nchan;
unsigned short fctr_och;
unsigned short och_pktsize, ich_plsize;

unsigned int tochplsize, tichplsize;

char *f_ptr[FDNUM];
char *modeptr;
char *log_option;

FILE *ichstream;
FILE *mult_stream[FDNUM];
FILE *seqstream;


int ext_serch(char *ichfile){

        int st=0;
        int cnt;

        for( cnt=0 ; ; cnt++ ){
                if(*(ichfile+cnt)=='.') break;
        }
        if(*(ichfile+cnt+0)!='.') st=-1;
        if(*(ichfile+cnt+1)!='i') st=-1;
        if(*(ichfile+cnt+2)!='c') st=-1;
        if(*(ichfile+cnt+3)!='h') st=-1;

        return st;
}



void itoa(int ctr, char *filecnt, int mode){

        sprintf(filecnt, "%d", ctr);

}

//------------------------------------------------------------------------
int main(int argc, char **argv)
{
	InitializeArrays();

/********************************************* Input Error Trapping ****************************************************/

	if((argc < 3) && (argc != 1))
	{

		*argv++;
		modeptr = *argv;

		if((strcmp(modeptr,"/n") != 0) && (strcmp(modeptr,"/c") != 0) && (strcmp(modeptr,"/h") != 0) 
			&& (strcmp(modeptr,"/N") != 0) && (strcmp(modeptr,"/C") != 0) && (strcmp(modeptr,"/H") != 0)
			&& (strcmp(modeptr,"/?") != 0))
		{
				printf("Invalid mode.\n");
				exit(1);

		}else if((strcmp(modeptr,"/h") == 0) || (strcmp(modeptr,"/?") == 0) || (strcmp(modeptr,"/H") == 0))
			{
				HelpScreen();
				exit(1);
			
		}else if((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/N") == 0) 
					|| (strcmp(modeptr,"/C") == 0))
			{
				printf("Too few parameters.\n");
				exit(1);
			}
	}
	else if(argc > 4)
		{
			printf("Too many parameters.\n");
			exit(1);
		}
	else if(argc == 1)
		{
			HelpScreen();
			exit(1);
		}


	else if(argc == 4)
		{
			*argv++;
			modeptr = *argv;

			if((strcmp(modeptr,"/n") != 0) && (strcmp(modeptr,"/c") != 0) && (strcmp(modeptr,"/N") != 0)
				&& (strcmp(modeptr,"/C") != 0))
			{
				printf("Invalid mode.\n");
				exit(1);
			}

			*argv++;
			strcpy(ichfile, *argv);

//			_splitpath(ichfile, drive, dir, fname, ext);

//			if (strcmp(ext, ".ich") != 0)
			if(ext_serch(ichfile))
			{
				printf("Source is not an ICH file.\n");
				exit(1);
			}

			*argv++;
			log_option = *argv;

			if((strcmp(log_option,"/+y") != 0) && (strcmp(log_option,"/+Y") != 0) && (strcmp(log_option,"/-y") != 0)
				&& (strcmp(log_option,"/-Y") != 0))
			{
				printf("Invalid log option.\n");
				exit(1);
			}
		}

	else if(argc == 3)
		{

				printf("Too few parameters.\n");
				exit(1);

		}

/****************************************************************************************************************/
 if((ichstream = fopen(ichfile, "rb" )) != NULL )
 {
	   fseek(ichstream, 0, SEEK_SET);
	   fread(&ichversion, sizeof(unsigned long), 1, ichstream );

	   fseek(ichstream, 4, SEEK_SET);
	   fread(&rate, sizeof(unsigned int), 1, ichstream );

	   fseek(ichstream, 8, SEEK_SET);
	   fread(&channel, sizeof(unsigned int),1,ichstream);


	#ifdef BYTESWAP
	   sw_datalong = ByteSwap32(ichversion);
	   ichversion = sw_datalong; 
	#endif
   
		if(ichversion != 0x10000000)						// check file version
		{
			printf("Could not read contents of ICH file.\n");
			exit(1);
		}

	#ifdef BYTESWAP
	   sw_dataint = (unsigned int) ByteSwap32((unsigned long)rate);
	   rate = sw_dataint;
	#endif

	//equivalent number of samples according to sampling rate setting
	switch( rate )
	{
		case 0x0000:
			nsamp = 192;
			break;
		case 0x0001:
			nsamp = 128;
			break;

		case 0x0002:
			nsamp = 64;
			break;
        
		case 0x0003:
			nsamp = 32;
			break;
       
		case 0x0004:
			nsamp = 192;
			break;
        
		case 0x0005:
			nsamp = 96;
			break;
        
		case 0x0006:
			nsamp = 48;
			break;

		default:
			printf("Could not read contents of ICH file.\n");  // displayed if number of samples is invalid
			exit(1);
	}

	//equivalent number of channels according to channel setting
	#ifdef BYTESWAP
	   sw_dataint = (unsigned int) ByteSwap32((unsigned long)channel);
	   channel = sw_dataint;
	#endif
	
	if ( channel!=0x0000 ){
		printf("Invalid channel number %d\n", channel);
		exit(1);
	}

	nchan = 16;

	/*******************************************************************************/

	fctr_och = (nchan/OCHCHAN);

	ich_plsize = (2*nsamp*nchan);							// payload size of 1 ich packet
	och_pktsize = (2*OCHCHAN*nsamp);						// size of 1 och packet

	fseek(ichstream, 18, SEEK_SET);	
	fread(&seqno[0], sizeof(unsigned short), i, ichstream);

	#ifdef BYTESWAP
		sw_datashort = ByteSwap16(seqno[0]);
		seqno[0] = sw_datashort;
	#endif
	
	fseek(ichstream, 20, SEEK_SET);					// set position to payload1, byte1 via ichstream
									// prepare to read first payload
	npacket = 0;
	seqstream = fopen(ichfile, "rb" );
	fseek(seqstream, 18, SEEK_SET);					// position of first seq. no. via seqstream
	fread(&nseq[npacket], sizeof(unsigned short), 1, seqstream);	// read sequence no. of 1st ich packet

	#ifdef BYTESWAP
		sw_datashort = ByteSwap16((unsigned short)nseq[npacket]);
		nseq[npacket] = sw_datashort;
	#endif


	while (!feof(seqstream))			// sequence number scan to get total number of packets
	{	
		npacket++;
		fseek(seqstream, (2+ich_plsize), SEEK_CUR);
		fread(&nseq[npacket], sizeof(unsigned short), 1, seqstream);

		#ifdef BYTESWAP
			sw_datashort = ByteSwap16((unsigned short)nseq[npacket]);
			nseq[npacket] = sw_datashort;
		#endif

	}


//	for (ctr=0; ctr<npacket; ctr++)
//		printf("packet count(%d) = %d sequence no.\n", ctr, nseq[ctr]);	// display sequence number of all ich packets	
																	

	ctrx=0;	
	miss=0;
	tmiss=0;

	for(ctrx=0; ctrx<(npacket-1); ctrx++)
	{
		diffx = nseq[ctrx+1] - nseq[ctrx];
		i_diffx = abs(diffx);
		miss = i_diffx-1;
		tmiss = tmiss + miss;					// calculate number of missing packets
	}

	tpacket = npacket + tmiss;

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		tichplsize = npacket * ich_plsize;
		tochplsize = npacket * och_pktsize;
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		tichplsize = npacket * ich_plsize;
		tochplsize = tpacket * och_pktsize;
	}


	/*************************** create directory name *******************************/

//	strcpy(des_dir, drive);
//	strcat(des_dir, dir);
//	strcpy(maskname, fname);
//	strcat(maskname, "_och");
//	strcat(des_dir, maskname);

	{
		int cnt;
		int cnt2;
		strcpy(des_dir, ichfile);
		for( cnt=0 ; ; cnt++ ){
			if(*(des_dir+cnt)=='.')	break;
		}
		for( cnt2=0 ; cnt2<4 ; cnt2++ ){
			*(des_dir+cnt)='\0';
		}
	}
	strcat(des_dir, "_och");

	/************************** display data *****************************************/

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
		printf("Performing normal mode. . .\n");

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
		printf("Performing confirm sequence mode. . .\n");

		printf("\n");
		printf("     Found number of channels in ICH file: %d channels\n", nchan);
		printf("     Found number of samples per channel: %d samples\n", nsamp);
		printf("     Found number of packets: %d packet(s)\n", npacket);
		printf("     ICH payload size per packet: %d bytes\n", ich_plsize);
		printf("     Total ICH payload size: %d bytes\n", tichplsize);

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		printf("\n");
		printf("     Total OCH payload size: %d bytes\n", tochplsize);
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		printf("\n");
		printf("     Found sequence errors: %d error(s)\n", tmiss);

		if(tmiss !=0)
			printf("     Padding 0x0000 data to %d extra packet(s)\n", tmiss); 

		printf("\n");	
		printf("     Total OCH payload size: %d bytes\n", tochplsize);
	}

		if( mkdir(des_dir, 0777) == 0 )						// create directory
		{
			printf("\n");
			printf("     New folder succesfully created.\n");
			printf("     New folder for OCH files: %s\n", des_dir);
		}
		else
		{
			printf("\n");
			printf("     Path to OCH files: %s\n", des_dir);
		}

	/*******************************************************************************/

	for(ctr=0; ctr<fctr_och; ctr++)							// create header loop for och
	{
		f_ptr[ctr] = &ochname[ctr][0];
		createOchName(ctr);
		Writeheader(ctr);
	} 

	if((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		printf("     Writing files. . .");
		while(indicator != EOF)
		{
			rd_ich_payload(nsamp, nchan);
			transpose_pkt(nsamp, nchan);

			fctrtype = fctr_och;

			for(ctr=0; ctr<fctrtype; ctr++)
			{
				div_pkt(ctr, nsamp);
				wr_audio(ctr, nsamp);
			}

			indicator=getc(ichstream);
			ungetc(indicator, ichstream);

			tmp++;
			fseek(ichstream, 4, SEEK_CUR);
		}
		printf("done!\n");
		printf("     %d OCH files written.\n", fctr_och);
	}


	if((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		tmp=0;
		diff=0;
		printf("     Writing files. . .");
		while(indicator != EOF)
		{

			diff = nseq[tmp+1] - nseq[tmp];
			i_diff = abs(diff);

			rd_ich_payload(nsamp, nchan);
			transpose_pkt(nsamp, nchan);

			fctrtype = fctr_och;

			for(ctr=0; ctr<fctrtype; ctr++)
			{
				div_pkt(ctr, nsamp);
				wr_audio(ctr, nsamp);
			}

			if(((i_diff-1) != 0)&&(tmp <(npacket-1)))
			{
				for(fill=1; fill<=(i_diff-1); fill++)
					for(ctr=0; ctr<fctrtype; ctr++)
					{
						div_pkt(ctr, nsamp);	// to preserve channel correspondence. if removed
								// only the final 4 channels of the ich file will be dummy

						wr_audio(ctr, nsamp);	// write data from previous packet as dummy data
					//	wr_dummy(ctr, nsamp);
					}
			}
			
			tmp++;
			fseek(ichstream, 4, SEEK_CUR);
			indicator=getc(ichstream);
			ungetc(indicator, ichstream);
		}
		printf("done!\n");
		printf("     %d OCH files written.\n", fctr_och);
	}

	/*******************************************************************************/


	if((strcmp(log_option,"/-y") == 0) || (strcmp(log_option,"/-Y") == 0))	// Prompt before creating log file
	{
		printf("\n");
		printf("Create log file (y/n)? ");
		createlog = getchar();

		if((createlog == 'y') || (createlog == 'Y'))				// user input ...create log file?
		{
			WriteLogFile(tpacket);											// write log file
			printf("Log file created.\n");
		}
		else
		{
			printf("Log file not created.\n");
		}
	}

	if((strcmp(log_option,"/+y") == 0) || (strcmp(log_option,"/+Y") == 0))	
	{
		printf("\n");
		WriteLogFile(tpacket);							// write log file
		printf("Log file created.\n");
	}

	/*******************************************************************************/

	fclose(ichstream);
	fclose(seqstream);


	fctrtype = fctr_och;

	for(i=0; i<fctrtype; i++)
		fclose(mult_stream[i]);

 }else
	{
		printf( "File not found or could not be opened.\n" );	
		exit(1);
	}

 return 0;

}		// end of main		


void InitializeArrays()
{
	memset(source, 0, (MAXSAMPLE*MAXCHANNEL));
	memset(tr_data, 0, (MAXSAMPLE*MAXCHANNEL));
	memset(div_data, 0, (MAXSAMPLE*OCHCHAN));
//	memset(dummy, 0, (MAXSAMPLE*OCHCHAN));
	memset(ichfile, 0, _MAX_PATH);
	memset(drive, 0, _MAX_DRIVE);
	memset(dir, 0, _MAX_DIR);
	memset(fname, 0, _MAX_FNAME);
	memset(ext, 0, _MAX_EXT);
	memset(nseq, 0, MAXPKT);
	memset(seqno, 0, MAXNSEQ);
}


void createOchName(unsigned short ctr)
{
	memset(ochname[ctr], 0, _MAX_PATH);
	itoa( ctr, filecnt, 10 );
	
	strcpy(ochname[ctr], des_dir);
	strcat(ochname[ctr], "/");
	strcpy(ochmask, oname);
	strcat(ochmask, filecnt);
	strcat(ochname[ctr], ochmask);
	strcat(ochname[ctr], suffix);

	if((mult_stream[ctr] = fopen(f_ptr[ctr], "wb" )) != NULL )
	{
	}else
	{
		printf( "Could not write OCH file!\n" );
		exit(1);
	}
}


void Writeheader(unsigned short ctr)
{
		if((mult_stream[ctr] = fopen(f_ptr[ctr], "ab" )) != NULL )
		{
			version = 0x20000000;			

				#ifdef BYTESWAP
					sw_datalong = ByteSwap32(version);
					version = sw_datalong;
				#endif

			fseek(mult_stream[ctr], 0, SEEK_SET);
			fwrite(&version, sizeof(unsigned long), 1, mult_stream[ctr] );

				#ifdef BYTESWAP
					sw_dataint = (unsigned int) ByteSwap32((unsigned long) rate);
					rate = sw_dataint;
				#endif

			fseek(mult_stream[ctr], 4, SEEK_SET);

			fwrite(&rate, sizeof(unsigned int), 1, mult_stream[ctr] );
/*
			fseek(mult_stream[ctr], 8, SEEK_SET);
			fwrite(&och_pktsize, sizeof(unsigned short),1, mult_stream[ctr]);
*/
			fseek(mult_stream[ctr], 8, SEEK_SET);	
			fwrite(&och_pktsize_resv, sizeof(unsigned short),1, mult_stream[ctr]);		// reserved (och payload size)

/*
			if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
			{
				fseek(mult_stream[ctr], 10, SEEK_SET);
				fwrite(&npacket, sizeof(unsigned short), 1, mult_stream[ctr]);
			}
*/
			if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
			{
				fseek(mult_stream[ctr], 10, SEEK_SET);
				fwrite(&npacketresv, sizeof(unsigned short), 1, mult_stream[ctr]);		// reserved (number of payloads)
			}
/*
			if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
			{
				fseek(mult_stream[ctr], 10, SEEK_SET);
				fwrite(&tpacket, sizeof(unsigned short), 1, mult_stream[ctr]);
			}
*/
			if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
			{
				fseek(mult_stream[ctr], 10, SEEK_SET);
				fwrite(&tpacketresv, sizeof(unsigned short), 1, mult_stream[ctr]);		// reserved (number of payloads including miss)
			}


			fseek(mult_stream[ctr], 12, SEEK_SET);
			fwrite(&resv, sizeof(unsigned int), 1, mult_stream[ctr]);
		}else
		{
			printf( "Could not write OCH file!\n" );
			exit(1);
		}
}


void rd_ich_payload(unsigned short nsamp, unsigned short nchan)
{
	fseek(ichstream, 0, SEEK_CUR);
	for(i=0; i<(nsamp*nchan); i++){
		fread(&source[i], sizeof(unsigned short), 1, ichstream);
	}
}


/*
void transpose_pkt(unsigned short nsamp, unsigned short nchan)			// previous
{
	unsigned short m;
	m=0;

	for(i=0; i<nsamp; i++)
	{
		for (j=0; j<nchan; j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}
}
*/


void transpose_pkt(unsigned short nsamp, unsigned short nchan)			// corrected data arrangement
{
	unsigned short m;
	m=0;

	// the before 2ms
	for(i=0; i<nchan; i++)
	{
		for (j=0; j<nsamp/2; j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}

	// the after 2ms
	for(i=0; i<nchan; i++)
	{
		for (j=nsamp/2; j<nsamp; j++)
		{
			tr_data[i][j] = source[m];
			m++;
		}
	}
			
}


/*
void div_pkt(unsigned short ctr, unsigned short nsamp)					// previous
{
	unsigned short functype;
	unsigned short z;
	unsigned short ch_start, ch_end;

	functype = OCHCHAN;

	z=0;

	ch_start=0+(functype*ctr);
	ch_end=functype+(functype*ctr);

	for(i=0; i<nsamp; i++)
	{
		for(j=ch_start; j<ch_end; j++)
		{
			div_data[z] = tr_data[i][j];
			z++;
		}
	}
}
*/


void div_pkt(unsigned short ctr, unsigned short nsamp)					// corrected data arrangement
{
	unsigned short functype;
	unsigned short z;
	unsigned short ch_start, ch_end;

	functype = OCHCHAN;

	z=0;

	ch_start=0+(functype*ctr);
	ch_end=functype+(functype*ctr);

	// the before 2ms
	for(i=ch_start; i<ch_end; i++)
	{
		for(j=0; j<nsamp/2; j++)
		{
			div_data[z] = tr_data[i][j];
			z++;
		}
	}

	// the after 2ms
	for(i=ch_start; i<ch_end; i++)
	{
		for(j=nsamp/2; j<nsamp; j++)
		{
			div_data[z] = tr_data[i][j];
			z++;
		}
	}

}


void wr_audio(unsigned short ctr, unsigned short nsamp)
{
	unsigned short functype;

	functype = OCHCHAN;

	fseek(mult_stream[ctr], 0, SEEK_CUR);
	fwrite(&div_data, sizeof(unsigned short),(nsamp*functype), mult_stream[ctr]);
}

/*
void wr_dummy(unsigned short ctr, unsigned short nsamp)
{
	unsigned short functype;

	functype = OCHCHAN;

	fseek(mult_stream[ctr], 0, SEEK_CUR);

	for(i=0; i<(nsamp*functype); i++)
		dummy[i] = 0;

	fwrite(&dummy, sizeof(unsigned short), (nsamp*functype), mult_stream[ctr]);	
}
*/

void HelpScreen()
{
	printf("Translates an ICH file into OCH files\n");
	printf("\n");
	printf("ICHTOOCH [MODE] [SOURCE] [LOG OPTION]\n");
	printf("\n");
	printf("MODE\n");
	printf("   /N        Normal mode. Reads packets sequentially\n");
	printf("             and ignores missing sequence number.\n");
	printf("   /C        Confirm sequence mode. Creates extra packets with\n");
	printf("             dummy padding data for the missing sequence number.\n");
	printf("\n");
	printf("SOURCE       Path and name of target ICH file.\n");
	printf("\n");
	printf("LOG OPTION\n");
	printf("   /+Y       Create log file.\n");
	printf("   /-Y       Prompt before creating log file.\n");
}


void WriteLogFile(unsigned int totalpkt)
{
	FILE *logfile;
	
	char logpath[_MAX_PATH];
	unsigned short ctrl = 0;
	unsigned int xctr=0;
	unsigned int xcount=0;
	unsigned int logsize=420;
	int nbytes =0;

	strcpy(logpath, des_dir);
	strcat(logpath, "/");
	strcat(logpath, "lost.log");


  if( (logfile = fopen(logpath, "w+t" )) != NULL )
  {

	/************************** display data *****************************************/

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
		fprintf(logfile, "Log file for normal mode\n");

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
		fprintf(logfile, "Log file for confirm sequence mode\n");

		fprintf(logfile, "\n");
		fprintf(logfile, "     Found number of channels in ICH file: %d channels\n", nchan);
		fprintf(logfile, "     Found number of samples per channel: %d samples\n", nsamp);
		fprintf(logfile, "     Found number of packets: %d packet(s)\n", npacket);
		fprintf(logfile, "     ICH payload size per packet: %d bytes\n", ich_plsize);
		fprintf(logfile, "     Total ICH payload size: %d bytes\n", tichplsize);

	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		fprintf(logfile, "\n");
		fprintf(logfile, "     Total OCH payload size: %d bytes\n", tochplsize);
	}

		fprintf(logfile, "\n");
		fprintf(logfile, "     Found sequence errors: %d error(s)\n", tmiss);

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		if(tmiss !=0)
			fprintf(logfile, "     Padding 0x0000 data to %d extra packet(s)\n", tmiss); 

		fprintf(logfile, "\n");	
		fprintf(logfile, "     Total OCH payload size: %d bytes\n", tochplsize);
	}

		if( mkdir(des_dir, 0x777) == 0 )										// create directory
		{
			fprintf(logfile, "\n");
			fprintf(logfile, "     New folder succesfully created.\n");
			fprintf(logfile, "     New folder for OCH files: %s\n", des_dir);
		}
		else
		{
			fprintf(logfile, "\n");
			fprintf(logfile, "     Path to OCH files: %s\n", des_dir);
		}

		fprintf(logfile, "\n");
		fprintf(logfile, "   Sequence number detail\n");

		
	/************************** Missing Sequence Number ****************************/
	if ((strcmp(modeptr,"/n") == 0) || (strcmp(modeptr,"/N") == 0))
	{
		while(xctr<totalpkt)
		{
			ctrl = xctr%65536;	
			if (nseq[xcount] == ctrl)
			{
//				fprintf(logfile, "     sequence no.(%d) : present. \n", ctrl);		
				xcount++;
				xctr++;
			}
			else
			{
				nbytes = fprintf(logfile, "*   sequence no.(%d) : missing....... ignored.\n", ctrl);
				logsize = logsize+nbytes;
				if(logsize >= 1000000)
				{
					printf("Log file truncated.\n");
					fprintf(logfile, "\n---- logfile truncated.");
					break;
				}
				xctr++;		
			}
		}
	}

	if ((strcmp(modeptr,"/c") == 0) || (strcmp(modeptr,"/C") == 0))
	{
		while(xctr<totalpkt)
		{
			ctrl = xctr%65536;
			if (nseq[xcount] == ctrl)
			{
//				fprintf(logfile, "     sequence no.(%d) : present. \n", ctrl);		
				xcount++;
				xctr++;
			}
			else
			{
				nbytes = fprintf(logfile, "*   sequence no.(%d) : missing....... dummy data padded.\n", ctrl);
				logsize = logsize+nbytes;
				if(logsize >= 1000000)
				{
					printf("Log file truncated.\n");
					fprintf(logfile, "\n---- logfile truncated.");
					break;
				}
				xctr++;		
			}
		}
	}


	fprintf(logfile, "\n\n");
	fprintf(logfile, "---- end of log -----");

	fclose(logfile);

	/*******************************************************************************/
  }else
  {
	  printf( "Problem creating log.\n" );
	  exit(1);
  }

}
